open Des

let key = "\001\035\069\103\137\171\205\239" (*0x0123456789abcdef*)

let plaintext = "\001\035\069\103\137\171\205\231" (*0x0123456789abcde7*)

let cipher_ref = "\201\087\068\037\106\094\211\029" (*0xc95744256a53d31d*)

let string_to_hex s =
  Printf.sprintf "%02x%02x%02x%02x%02x%02x%02x%02x"
    (Char.code s.[0]) (Char.code s.[1]) (Char.code s.[2]) (Char.code s.[3])
    (Char.code s.[4]) (Char.code s.[5]) (Char.code s.[6]) (Char.code s.[7])

let ctx = init_ctx key
let enc = des_block ctx ENCODE plaintext
let dec = des_block ctx DECODE enc;;

Printf.printf "plain:\t\t%s\ndecoded:\t%s\n\ncipher:\t\t%s\nencoded:\t%s\n"
  (string_to_hex plaintext) (string_to_hex dec)
  (string_to_hex cipher_ref) (string_to_hex enc)

let data = "\000\000\000\000\001\000\000\000\002\000\000\000\003\000\000\000"
  ^ "\004\000\000\000\005\000\000\000\006\000\000\000\007\000\000\000"
  ^ "\008\000\000\000\009\000\000\000"

let enc = des_string ctx ENCODE data
let dec = des_string ctx DECODE enc;;

let rec aux s off len =
  if off = len then ""
  else (Printf.sprintf "%02x" (Char.code s.[off])) ^ (aux s (off + 1) len);;

Printf.printf "block encode: %s\n" (aux enc 0 (String.length enc));
Printf.printf "block decode: %s\n" (aux dec 0 (String.length dec));
