open Safeloader
open Nat

let waste_digit = create_nat 1

let sq_mod_n x n n_digits =
  let len_x = num_digits_nat x 0 (length_nat x) in
  let alloc_sq_x = 3 * n_digits in
  let sq_x = make_nat alloc_sq_x in
  let _ = square_nat sq_x 0 alloc_sq_x x 0 len_x in
  let len_sq_x = num_digits_nat sq_x 0 alloc_sq_x in
  if eq_nat sq_x 0 len_sq_x n 0 n_digits then (nat_of_int 0)
  else begin
    div_nat sq_x 0 alloc_sq_x n 0 n_digits;
    set_to_zero_nat sq_x n_digits (alloc_sq_x - n_digits);
    copy_nat sq_x 0 (num_digits_nat sq_x 0 alloc_sq_x)
  end

let sq_and_mult a k_in n digits =
  let k_len = num_digits_nat k_in 0 (length_nat k_in) in
  if is_zero_nat k_in 0 k_len
  then (nat_of_int 1)
  else begin
    let k = copy_nat k_in 0 k_len in
      (*step 1 & 3*)
    let len_a = num_digits_nat a 0 (length_nat a) in
    let big_a = make_nat digits in
    blit_nat big_a 0 a 0 len_a;
    let b = make_nat digits in
    if is_digit_odd k 0
    then blit_nat b 0 big_a 0 len_a
    else blit_nat b 0 (nat_of_int 1) 0 1;
    let t = k_len * length_of_digit
	- num_leading_zero_bits_in_digit k (k_len - 1) in
    shift_right_nat k 0 (num_digits_nat k 0 k_len) waste_digit 0 1;
    for i = 1 to t do
	(*step 4.1*)
      let new_a = sq_mod_n big_a n digits in
      let num_digits_big_a =
	num_digits_nat new_a 0 (length_nat new_a) in
      blit_nat big_a 0 new_a 0 num_digits_big_a;
      set_to_zero_nat big_a num_digits_big_a (digits - num_digits_big_a);
	(*step 4.2*)
      if is_digit_odd k 0
      then begin
	let num_digits_b = num_digits_nat b 0 (length_nat b) in
	let alloc_ab = 2 * digits in
	let ab = make_nat alloc_ab in
	let _ = mult_nat ab 0 alloc_ab big_a 0 num_digits_big_a
	    b 0 num_digits_b in
	let len_ab = num_digits_nat ab 0 alloc_ab in
	div_nat ab 0 alloc_ab n 0 digits;
	blit_nat b 0 ab 0 digits
      end; (* is_digit_odd *)
      shift_right_nat k 0 (num_digits_nat k 0 (length_nat k)) waste_digit 0 1;
    done;
    b
  end
