#include <caml/mlvalues.h>
#include <caml/alloc.h>
#include <caml/memory.h>

#define get3(s) ((((s)[0] & 0xff) << 16) | (((s)[1] & 0xff) << 8) | ((s)[2] & 0xff))
#define get2(s) ((((s)[0] & 0xff) << 8) | ((s)[1] & 0xff))

value string_to_ehdr(value s)
{
     value src;
     value dest;
     value result;
     char *cp;

     if (string_length(s) < 14)	
	  failwith("string_to_ehdr: string is too short");
     Begin_roots3(src, dest, result);
      cp = String_val(s);
      dest = alloc_tuple(2);
      Field(dest, 0) = Val_int(get3(cp));
      Field(dest, 1) = Val_int(get3(cp + 3));
      src = alloc_tuple(2);
      Field(src, 0) = Val_int(get3(cp + 6));
      Field(src, 1) = Val_int(get3(cp + 9));
      result = alloc(3, 0);
      Field(result, 0) = dest;
      Field(result, 1) = src;
      Field(result, 2) = Val_int(get2(cp + 12));
    End_roots();
    return result;
}

value ehdr_to_string(value hdr)
{
     unsigned char str[15];
     unsigned int tmp;

     str[14] = '\0';
     tmp = Int_val(Field(Field(hdr, 0), 0)); /* dest addr, initial bytes */
     str[0] = (tmp >> 16) & 0xff;
     str[1] = (tmp >> 8) & 0xff;
     str[2] = tmp & 0xff;
     tmp = Int_val(Field(Field(hdr, 0), 1)); /* dest addr, final bytes */
     str[3] = (tmp >> 16) & 0xff;
     str[4] = (tmp >> 8) & 0xff;
     str[5] = tmp & 0xff;
     tmp = Int_val(Field(Field(hdr, 1), 0)); /* src addr, initial bytes */
     str[6] = (tmp >> 16) & 0xff;
     str[7] = (tmp >> 8) & 0xff;
     str[8] = tmp & 0xff;
     tmp = Int_val(Field(Field(hdr, 1), 1)); /* src addr, final bytes */
     str[9] = (tmp >> 16) & 0xff;
     str[10] = (tmp >> 8) & 0xff;
     str[11] = tmp & 0xff;
     tmp = Int_val(Field(hdr, 2)); /* protocol */
     str[12] = (tmp >> 8) & 0xff;
     str[13] = tmp & 0xff;
     return copy_string(str);
}
