open Ether

let hdr = { dst = ( 0x123456, 0x789abc );
	    src = ( 0xfedcba, 0x987654 );
	    proto = 0x5a5a }

let str = "\222\173\250\206\012\171\222\173\190\239\012\171\165\165"

let res_hdr = string_to_ehdr str

let res_str = ehdr_to_string hdr

let dump_hdr hdr =
  let (d1, d2) = hdr.dst in
  let (s1, s2) = hdr.src in
  Printf.printf "dst: %06x.%06x src: %06x.%06x proto: %04x\n"
    d1 d2 s1 s2 hdr.proto

let dump_str labl s =
  Printf.printf "%s: " labl;
  for i = 0 to 13 do
    Printf.printf "%02x" (Char.code s.[i])
  done;
  Printf.printf "\n";;

Printf.printf "hdr -> str\n";;
dump_hdr hdr;;
dump_str "res_str" res_str;;
Printf.printf "\nstr -> hdr\n";;
dump_str "str" str;;
dump_hdr res_hdr;;
