(* 
 * $Id: activehost.ml,v 1.1 1997/12/05 19:16:36 mwh Exp $
 * $Revision: 1.1 $
 *
 * This file defines the concept of a host in the network
 *
 *)
open Unix

type activehost = Unknown | IPv4UDP of Unix.inet_addr * int
exception Not_known

let activeHostToString a =
  match a
  with
    Unknown -> "Unknown"
  | IPv4UDP (addr,port) -> 
      "IPv4UDP: (" ^ (string_of_inet_addr addr) ^ "," ^ 
      (string_of_int port) ^ ")"

let getHostPort s defport =
  let len = String.length s in
  let rec getidx n =
    if n = len then raise Not_found 
    else
      if s.[n] = ':' then n else getidx (n+1) in
  try
    let idx = (getidx 0) in
    ((String.sub s 0 idx),
     int_of_string (String.sub s (idx+1) (len-idx-1)))
  with Not_found ->
    (s,defport)

let stringToActiveHost s defPort =
  try 
    let (h,p) = getHostPort s defPort in
    IPv4UDP (((Unix.gethostbyname h).Unix.h_addr_list).(0),p)
  with
    _ -> raise Not_known

(*

type 'a option = NONE | SOME of 'a

let hostTable: (string * activehost) list option ref = ref NONE
let me: activehost option ref = ref NONE

let getHostByName name =
  match 
    !hostTable
  with
    NONE -> raise Not_known
  | SOME mappings ->
    try
      List.assoc name mappings
    with Not_found -> raise Not_known

let thisHost () =
  match
    !me
  with
    NONE -> raise Not_known
  | SOME id -> id

let initHostInfo name mappings =
  me := SOME name;
  hostTable := SOME mappings
*)













