open Safeloader
open Safeunix
open An_marshal
open Wf
(*open Time*)

let pktcounter = ref 0
let pkttimer = ref 0.0
let pktfinal = ref 0.0

let pktinc a =
  if (!pktcounter = 0)
  then pkttimer := gettimeofday ()
  else (if (!pktcounter >= 100) then pktfinal := gettimeofday ());
  pktcounter := !pktcounter + 1; ""

let pkttime a =
  Log.log_msg (Printf.sprintf "Packet timer start %f end %f\n" !pkttimer !pktfinal); ""

let pktzero a =
  pktcounter := 0; ""
 
let pktprint a =
  Log.log_msg (Printf.sprintf "Packet counter = %d\n" !pktcounter); ""

let value = ref None

let hashval() =
  match !value with
    None -> failwith "hash value not set!  (This can't happen.)"
  | Some(v) -> v

let die = ref false

(*
 * getAddress tells a switchlet what the AN address of the current
 * node is.
 *)
let getAddress () =
  let name = Safeunix.gethostname () in
  try
    let i = String.index name '.' in
    String.sub name 0 i
  with Not_found -> name

(*
 * This functions just sits around waiting for a packet to arrive
 * on Type_ID 20.
 *)
let receive () = 
  register_type_id 20;
  Route.route_init "rt.table";
  while not !die do
    let (wf_hdr , optlist , func_name, code , datastr ) = recv_wf 20 in
    let enc = encode {code=code; data=datastr; func=func_name} in
    Func.do_op (Func.LOADS(code));
    Func.do_op (Func.EXEC(func_name, enc))
  done;
  unregister_type_id 20

let start_recvr ignored =
  receive ();
  ""

let _ = Func.register "pktinc" pktinc
let _ = Func.register "pktzero" pktzero
let _ = Func.register "pktprint" pktprint
let _ = Func.register "pkttime" pkttime
let _ = value := Some(Func.register "start_recvr" start_recvr)
