open Safeloader
open Bob

type bridge_configuration = { bridge_id : identifier;
			      bridge_max_age : int;
			      bridge_hello_time : int;
			      bridge_forward_delay : int }

let config_hash = Hashtbl.create 23

let config_max_age = 0x1400
let config_bridge_hello_time = 0x0200
let config_bridge_forward_delay = 0x0f00

let _ = Hashtbl.add config_hash "bob"
  { bridge_id={ priority1=0; priority2=0x80; addr1=0; addr2=0; addr3=0xc0;
	       	addr4=0x80; addr5=0xe8; addr6=0xe7};
    bridge_max_age = config_max_age;
    bridge_hello_time = config_bridge_hello_time;
    bridge_forward_delay = config_bridge_forward_delay }

let _ = Hashtbl.add config_hash "switchlet"
  { bridge_id={ priority1=0; priority2=0x80; addr1=0; addr2=0; addr3=0xc0;
	       	addr4=0x93; addr5=0x59; addr6=0xf9};
    bridge_max_age = config_max_age;
    bridge_hello_time = config_bridge_hello_time;
    bridge_forward_delay = config_bridge_forward_delay }

let _ = Hashtbl.add config_hash "oilhead"
  { bridge_id={ priority1=0; priority2=0x01; addr1=0; addr2=0; addr3=0xc0;
	       	addr4=0x9b; addr5=0x7d; addr6=0xe7};
    bridge_max_age = config_max_age;
    bridge_hello_time = config_bridge_hello_time;
    bridge_forward_delay = config_bridge_forward_delay }

let _ = Hashtbl.add config_hash "horsemen"
  { bridge_id={ priority1=0; priority2=0x01; addr1=0; addr2=0; addr3=0xc0;
	       	addr4=0x7e; addr5=0xe8; addr6=0xe7};
    bridge_max_age = config_max_age;
    bridge_hello_time = config_bridge_hello_time;
    bridge_forward_delay = config_bridge_forward_delay }
