(* 
 * $Id: defaultroute.ml,v 1.1 1997/12/05 19:16:37 mwh Exp $
 *
 * Provides the default routing service.  Is intialized at
 * PLAN startup time with the actual routing function to use
 * as the default.
 *
 * $Revision: 1.1 $
 *)

(* Currently set to no routing at all -- is this what we really want? *)

let rout_fun = ((ref None):(Activehost.activehost -> 
                            Activehost.activehost) option ref)

exception No_route

let set_rout_fun rfun =
  rout_fun := Some rfun

let next_hop dest =
  match !rout_fun with
    None -> raise No_route
  | Some rfun -> rfun dest

