module type IP =
  sig
    type port

    type hdr

    exception Already_bound

    val bind_proto : int -> port
    val unbind_proto : port -> unit

    val get_packet : port -> hdr * string

    val send : port -> hdr -> string -> int
    val reply : port -> hdr -> string -> int

    val get_source : hdr -> string
    val get_dest : hdr -> string
  end
