type ip_port

type ip_addr = int * int * int * int

type ip_hdr =
    { version : int;			(*4 bits*)
      ihl : int;			(*4 bits*)
      tos : int;			(*8 bits*)
      length : int;			(*16 bits*)
      id : int;				(*8 bits*)
      flags : int;			(*3 bits*)
      frag_offset : int;		(*13 bits*)
      ttl : int;			(*8 bits*)
      protocol : int;			(*8 bits*)
      hdr_chksum : int;			(*16 bits*)
      source_addr : ip_addr;		(*32 bits*)
      dest_addr : ip_addr		(*32 bits*)
    }

type ip_pkt = { ip_hdr : ip_hdr; ip_data : string; ip_ehdr : Local.ehdr;
		ip_uaddr : Safeunix.sockaddr }

exception Already_bound

val die: bool Safestd.ref

val bind_ip_proto: int -> ip_port
val unbind_ip_proto: ip_port -> unit

val get_packet: ip_port -> ip_pkt

val send_packet: ip_port -> string -> int -> int -> Safeunix.sockaddr -> int
val send_ip: ip_port -> ip_pkt -> int
val reply_ip: ip_port -> ip_pkt -> int
