module IPaddr : IPaddr.IPADDR =
  struct
    type ip_addr = int * int * int * int

    let to_unix (a1, a2, a3, a4) =
      Unix.inet_addr_of_string (Printf.sprintf "%d.%d.%d.%d" a1 a2 a3 a4)

    let from_unix addr =
      let str = Unix.string_of_inet_addr addr in
      let l = List.map int_of_string (Str.split (Str.regexp "\.") str) in
      match l with
	[a; b; c; d] -> (a, b, c, d)
      |	_ -> raise (Failure "from_unix")
  end
