open Safestd

(* must have even len *)
let rec continue_ipcsum partial s ofs len =
  let get_u16 s ofs =
    ((Char.code (String.get s ofs)) lsl 8) lor
    (Char.code (String.get s (ofs + 1))) in
  if len = 0 then partial
  else
    let tmp = partial + (get_u16 s ofs) in
    let stp = (tmp land 0xffff) + (tmp lsr 16) in
    continue_ipcsum stp s (ofs + 2) (len - 2)

let ipcsum_step partial s ofs len =
  let even n = n land 1 = 0 in
  if even len then continue_ipcsum partial s ofs len
  else
    let base = continue_ipcsum partial s ofs (len - 1) in
    let str = Printf.sprintf "%c%c" (String.get s (ofs + len - 1)) '\000' in
    continue_ipcsum base str 0 2

let ipcsum_complete partial = 0xffff - partial

let ipcsum s ofs len = ipcsum_complete (ipcsum_step 0 s ofs len)
