open Safestd
open Safeunix
open Unixnet
open Safethread
open Log

let ether_type_DOD_INTERNET = 0x800

let die = ref false
let die_mutex = Mutex.create ()
let die_condition = Condition.create ()

let ip_hashtable = Hashtbl.create 257
let ip_hasm_m = Mutex.create ()

let top_thread () =
  let start_m = Mutex.create () in
  let rec start_handlers () =
    let iport = bind_type ether_type_DOD_INTERNET in
    Safethread.create (hashval())
    get_ip (iport, ip_hashtable, ip_hash_m, start_m)
  in
  let tid = Mutex.lock start_m; start_handlers () in
  Mutex.unlock start_m;
  Mutex.lock die_mutex;
  while not !die do
    Condition.wait die_condition die_mutex
  done;
  Safethread.kill tid

let ipdemux ignored =
  let t = Safethread.create (hashval()) top_thread () in
  Safethread.join t;
  ""

let _ = value := Some(Func.register "ipdemux" ipdemux)
