(*let do_dump idx nm =
  let file = open_out nm in
  let report_fn s =
    output_string file s; output_char file '\n' in
  Time.register_report_fun report_fn;
  Time.dump_samples idx 0 999;
  close_out file*)

let _ =
  let r = Gc.get () in
  r.Gc.minor_heap_size <- 128 * 1024;
  Gc.set r;
  try
    let lexbuf = Lexing.from_channel stdin in
    Dynlink.init();
    Dynlink.add_available_units Crcs.crc_unit_list;
    while true do
      Safeloader.Func.do_op (Cmds.main Lexcmd.token lexbuf);
    done
  with Lexcmd.Eof ->
    begin
      (*do_dump 0 "intro-data";
      do_dump 1 "cur-data";
      do_dump 2 "patch-data";
      do_dump 3 "update-data";
      do_dump 4 "reify-data";
      do_dump 5 "call-data";*)
      exit 0
    end
  | e -> Printexc.catch (fun () -> raise e) ()
