type local_port

type eaddr = int * int
type ehdr = { dst : eaddr; src : eaddr; proto : int }
type local_pkt = { ehdr : ehdr; data : string; uaddr : Safeunix.sockaddr }

exception Already_bound

val die: bool Safestd.ref

val bind_local_type: string -> local_port
val unbind_local_type: local_port -> unit

val get_packet: local_port -> local_pkt

val send_packet: local_port -> string -> int -> int -> Safeunix.sockaddr -> int
val send_local_pkt: local_port -> local_pkt -> int
val reply_local_pkt: local_port -> local_pkt -> int

