open Activehost
open Safestd

let defService = ref "a"

(* splits the string in two, into a host and service pair *)
let getHostService s def =
  let len = String.length s in
  let rec getidx n =
    if n = len then raise Not_found 
    else
      if s.[n] = ':' then n else getidx (n+1) in
  try
    let idx = (getidx 0) in
    ((String.sub s 0 idx),
     (String.sub s (idx+1) (len-idx-1)))
  with Not_found ->
    (s,def)

let lookup name =
  let (name,serv) = (getHostService name !defService) in
  let c = serv.[0] in
  let port = ((Char.code c) - (Char.code 'a')) + 5000 in
  Activehost.stringToActiveHost (name ^ ":" ^ (string_of_int port)) 0
