(* 
 * $Id: routtab.mli,v 1.1 1997/12/05 19:16:37 mwh Exp $
 *
 * Provides the default routing service.  Is intialized at
 * PLAN startup time with the actual routing function to use
 * as the default.
 *
 * $Revision: 1.1 $
 *)

(* As per discussion with salex 12/2/97:

   The purpose of this route table is to map lowest level addresses
   to lowest level addresses (of course, what the "lowest" level means
   might actually change, but not as far as the user can tell).  If
   you want a nameservice, you have to invoke one specially.  See the
   activehost module for more details. *)

type rout_table

exception BadRouteTableFile of string
exception No_route

val init_table : string -> int -> rout_table
val next_hop : Activehost.activehost * rout_table -> Activehost.activehost

