module Rand = struct
let waste = Nat.create_nat 1

let rand_bytes num_bytes =
  let chan = open_in_bin "/dev/urandom" in
  let len_res = num_bytes / 4 in
  let res = Nat.create_nat len_res in
  let rec aux n =
    if n < 0 then ()
    else begin
      Nat.set_digit_nat res n
	(((input_byte chan) lsl 8) lor (input_byte chan));
      Nat.shift_left_nat res n 1 waste 0 16;
      let v2 = Nat.nat_of_int
	  (((input_byte chan) lsl 8) lor (input_byte chan)) in
      Nat.lor_digit_nat res n v2 0;
      aux (n - 1)
    end in
  aux (len_res - 1);
  close_in chan;
  res
end
