module Safeudp : sig
  type port

  type hdr = { src_port : int;	(*XXX*)
	       dst_port : int;
	       src_addr : Safeunix.inet_addr;
	       dst_addr : Safeunix.inet_addr
	     }

  exception Already_bound

  val bind_proto : int -> port
  val unbind_proto : port -> unit

  val get_packet : port -> hdr * int * string

  val send : port -> hdr -> string -> int
  val reply : port -> hdr -> string -> int

  val get_source : hdr -> Safeunix.inet_addr
  val get_dest : hdr -> Safeunix.inet_addr
end
