open Safestd
open Unixnet

type eaddr = int * int

let get_eaddr s ofs =
  let a = Char.code (String.get s ofs) in
  let b = Char.code (String.get s (ofs + 1)) in
  let c = Char.code (String.get s (ofs + 2)) in
  let d = Char.code (String.get s (ofs + 3)) in
  let e = Char.code (String.get s (ofs + 4)) in
  let f = Char.code (String.get s (ofs + 5)) in
  ((a lsl 16) lor (b lsl 8) lor c, (d lsl 16) lor (e lsl 8) lor f)

type ipaddr = int * int * int * int

let get_ipaddr s ofs =
    (Char.code (String.get s ofs),
     Char.code (String.get s (ofs + 1)),
     Char.code (String.get s (ofs + 2)),
     Char.code (String.get s (ofs + 3)))

let rec foo ignored =
  try
    let port = get_iport () in
    match status_in port GETHWADDR with
      None -> raise Exit
    | Some(addr) ->
      	let (eth1, eth2) = get_eaddr addr 0 in
      	Printf.printf "eth: %06x.%06x " eth1 eth2;
	match status_in port GETIPADDR with
	  None -> raise Exit
	| Some(addr) ->
	    let (a, b, c, d) = get_ipaddr addr 0 in
	    Printf.printf "ip: %d.%d.%d.%d\n" a b c d;
      	    foo ""
  with No_interface -> ""

let _ = Func.register "foo" foo
