module type Udp =
  functor (Lower : Lower.LOWER) ->
  sig
    type udp_port

    type hdr

    exception Already_bound

    val die : bool Safeloader.ref

    val listen_udp_port : int -> udp_port
    val bind_udp_conn : Safeloader.Safeunix.inet_addr * Safeloader.Safeunix.inet_addr * int * int
      -> udp_port
    val unbind_udp : udp_port -> unit

    val get_packet : udp_port -> hdr * int * string

  (*val send_packet : udp_port -> string -> int -> int ->
    Safeloader.Safeunix.sockaddr -> int*)
    val send_udp : udp_port -> string -> int
    val sendto_udp : udp_port -> string -> Safeloader.Safeunix.inet_addr -> int -> int

    val get_src_addr : hdr -> Safeloader.Safeunix.inet_addr
    val get_dst_addr : hdr -> Safeloader.Safeunix.inet_addr
    val get_src_port : hdr -> int
    val get_dst_port : hdr -> int
  end
