open Safeloader

(*module UdpnetFUNCTOR : (Udp.Udp) =
  functor (Lower : Lower.LOWER) ->
  struct*)
module Lower = Safeudp
    type udp_port =
	UDP_LISTEN_PORT of Lower.port * int
      | UDP_CONN_PORT of Lower.port * Safeunix.inet_addr * int
	    * Safeunix.inet_addr * int

    type hdr = Lower.hdr

    exception Already_bound

    let die = ref false
(*    let die_mutex = Mutex.create ()
    let die_condition = Condition.create ()*)

    let listen_udp_port port =
      try
      	let lport = Lower.bind_proto port in
      	UDP_LISTEN_PORT(lport, port)
      with Lower.Already_bound -> raise Already_bound

    let bind_udp_conn conn =
      try
      	let (src_addr, dst_addr, src_port, dst_port) = conn in
      	let lport = Lower.bind_proto src_port in
	UDP_CONN_PORT(lport, dst_addr, dst_port, src_addr, src_port)
      with Lower.Already_bound -> begin
	raise Already_bound
      end

    let unbind_udp uport =
      match uport with
	UDP_CONN_PORT(lport, _, _, _, _) ->
	  Lower.unbind_proto lport
      | UDP_LISTEN_PORT(lport, _) ->
	  Lower.unbind_proto lport
      
    let get_packet uport =
      match uport with
	UDP_CONN_PORT(lport, _, _, _, _) ->
	  Lower.get_packet lport
      | UDP_LISTEN_PORT(lport, _) ->
	  Lower.get_packet lport

    let send_udp uport upkt =
      match uport with
	UDP_CONN_PORT(lport, dst_addr, dst_port, src_addr, src_port) ->
	  let hdr = { Lower.src_port=src_port;
		      Lower.dst_port=dst_port;
		      Lower.src_addr=src_addr;
		      Lower.dst_addr=dst_addr
		    } in
	  Lower.send lport hdr upkt
      |	UDP_LISTEN_PORT(_) -> raise (Invalid_argument "send_udp")

    let sendto_udp uport upkt to_addr to_port =
      match uport with
	UDP_CONN_PORT(lport, _, _, src_addr, src_port) ->
	  let hdr = { Lower.src_port=src_port;
		      Lower.dst_port=to_port;
		      Lower.src_addr=src_addr;
		      Lower.dst_addr=to_addr
		    } in
	  Lower.send lport hdr upkt
      |	UDP_LISTEN_PORT(lport, src_port) ->
	  let hdr = { Lower.src_port=src_port;
		      Lower.dst_port=to_port;
		      Lower.src_addr=Safeunix.inet_addr_any;
		      Lower.dst_addr=to_addr
		    }  in
	  Lower.send lport hdr upkt

    let get_src_addr hdr = Lower.get_source hdr
    let get_dst_addr hdr = Lower.get_dest hdr
    let get_src_port hdr = hdr.Lower.src_port
    let get_dst_port hdr = hdr.Lower.dst_port
(*  end*)
