type wf_hdr = { do_forward : bool;
		type_id : int
	      }

type eaddr = int * int
type addr_opt = IPv4 of Safeloader.Safeunix.inet_addr | IPv6 of string | Ethernet of eaddr

type integrity_opt = unit

type nn_auth_opt = SPKI of string | X509 of string

type auth_opt = HMAC of int

type opt = NN_AUTH of nn_auth_opt
  | INTEGRITY of integrity_opt
  | SOURCE of addr_opt
  | DEST of addr_opt
  | AUTH of auth_opt

type option = { priv : bool;
		discard : bool;
		option : opt
	      }

val register_type_id : int -> unit
val unregister_type_id : int -> unit

val register_spi : int -> string -> int -> string -> string -> unit
val unregister_spi : int -> int -> unit

val send_wf : Safeloader.Safeunix.inet_addr -> wf_hdr -> option list ->
  string -> string -> string -> unit

val recv_wf : int -> (wf_hdr * option list * string * string * string)

