open Safeloader
open Safeunix
open Log
open Wf
open Saneudp
open Time
open Safethread

let datsize = 12100

(*
 * This is routine that starts things off by handing the components
 * of an ANEP to send_wf.  We took one of Nettles Type_IDs = 20
 *)
let send_udp rout cod payload =
  send_wf rout {do_forward = true; type_id = 20}  []
    "udp_out" cod payload

(* Destination *)
let ad = "wendy"
let datum = String.make datsize 'a'
let payload = Printf.sprintf "%-11s%s" ad datum
let rout = (Route.get_route ad)
let cod = (Get_bytecode.get_bytecode "saneudp")

let rec dostuff cnt lim =
  if cnt < lim
  then (send_udp rout cod payload; dostuff (cnt + 1) lim)
  else lim

let _ = Log.log_msg (Printf.sprintf "%d\n" (String.length datum))
let _ = ((Log.log_msg (Printf.sprintf "%f\n" (Time.get_time()))); dostuff 0 100; (Log.log_msg (Printf.sprintf "%f\n" (Time.get_time()))))

let datum = String.make datsize 'b'
let payload = Printf.sprintf "%-11s%s" ad datum

let rec dostuff2 cnt lim =
  if cnt < lim
  then (send_udp rout cod payload; dostuff (cnt + 1) lim)
  else lim
  
let _ = ((Log.log_msg (Printf.sprintf "%f\n" (Time.get_time()))); dostuff2 0 1; (Log.log_msg (Printf.sprintf "%f\n" (Time.get_time()))))
