open Int32

let set_int32 (a,b) =
  ((int32_of_int a) lsl 16) lor (int32_of_int b)

let x5a5a5a5a = set_int32 (0x5a5a, 0x5a5a)
let x12345678 = set_int32 (0x1234, 0x5678)

let xstring_of_int32 v =
  let break32 v =
    let hi = v lsr 16 in
    let lo = v land (int32_of_int 0xffff) in
    ((int_of_int32 hi), (int_of_int32 lo)) in
  let (hi, lo) = break32 v in
  Printf.sprintf "x%04x%04x" hi lo

(*let rol32 v len =
  let xffffffff = set_int32 (0xffff, 0xffff) in
  let hi_mask = (xffffffff lsr (32 - len)) lsl (32 - len) in
  let lo_mask = lnot hi_mask in
  let hi_bits = hi_mask land v in
  let lo_bits = lo_mask land v in
  (lo_bits lsl len) lor (hi_bits lsr (32 - len))*)

let rol32 v len = (v lsr (32 - len)) lor (v lsl len)

let main () =
  Printf.printf "rol32 x5a5a5a5a 1 -> %s\n" (xstring_of_int32 (rol32 x5a5a5a5a 1));
  Printf.printf "rol32 x5a5a5a5a 5 -> %s\n" (xstring_of_int32 (rol32 x5a5a5a5a 5));
  Printf.printf "rol32 x5a5a5a5a 8 -> %s\n" (xstring_of_int32 (rol32 x5a5a5a5a 8));
  Printf.printf "rol32 x5a5a5a5a 13 -> %s\n" (xstring_of_int32 (rol32 x5a5a5a5a 13));
  Printf.printf "rol32 x5a5a5a5a 16 -> %s\n" (xstring_of_int32 (rol32 x5a5a5a5a 16));
  Printf.printf "rol32 x5a5a5a5a 24 -> %s\n" (xstring_of_int32 (rol32 x5a5a5a5a 24));
  Printf.printf "rol32 x5a5a5a5a 30 -> %s\n" (xstring_of_int32 (rol32 x5a5a5a5a 30));
  Printf.printf "rol32 x12345678 1 -> %s\n" (xstring_of_int32 (rol32 x12345678 1));
  Printf.printf "rol32 x12345678 5 -> %s\n" (xstring_of_int32 (rol32 x12345678 5));
  Printf.printf "rol32 x12345678 8 -> %s\n" (xstring_of_int32 (rol32 x12345678 8));
  Printf.printf "rol32 x12345678 13 -> %s\n" (xstring_of_int32 (rol32 x12345678 13));
  Printf.printf "rol32 x12345678 16 -> %s\n" (xstring_of_int32 (rol32 x12345678 16));
  Printf.printf "rol32 x12345678 24 -> %s\n" (xstring_of_int32 (rol32 x12345678 24));
  Printf.printf "rol32 x12345678 30 -> %s\n" (xstring_of_int32 (rol32 x12345678 30));
  exit 0

let _ = main()

