open Sha1

let main () =
  let ctx = sha1init () in
  if (Array.length Sys.argv) < 2 then
    raise Exit;
  sha1update ctx Sys.argv.(1);
  let digest = String.create 20 in
  sha1final digest ctx;
  for i = 0 to 4 do
    for j = 0 to 3 do
      Printf.printf "%02X" (Char.code (digest.[i*4+j]))
    done;
    Printf.printf " "
  done;
  Printf.printf "\n"

let _ = Printexc.catch main ()

