#include <stdio.h>
#include "ip_sha1.h"

main(int argc, char **argv)
{
     SHA1_CTX ctx;
     int reps = 1;
     char *string;
     char **ap;
     int len;
     unsigned char digest[20];
     int i;

     SHA1Init(&ctx);
     if (argc < 2)
     {
	  fprintf(stderr, "usage: %s [-r reps] string\n", argv[0]);
	  exit(1);
     }

     ap = argv + 1;
     while ((*ap)[0] == '-')
     {
	  switch ((*ap)[1])
	  {
	  case 'r':
	       reps = atoi(ap[1]);
	       ap = ap + 2;
	       break;

	  default:
	       fprintf(stderr, "usage: %s [-r reps] string\n", argv[0]);
	       exit(1);
	  }
     }

     string = *ap;
     len = strlen(string);

     for (i = 0; i < reps; i++)
	  SHA1Update(&ctx, string, len);

     SHA1Final(digest, &ctx);

     for (i = 0; i < 5; i++)
     {
	  int j;

	  for (j = 0; j < 4; j++)
	       printf("%02X", digest[i*4+j]);
	  putchar(' ');
     }
     putchar('\n');

     exit(0);
}
