#include <caml/mlvalues.h>
#include <caml/alloc.h>
#include <caml/memory.h>
#include "ip_sha1.h"

value sha1_ctxcopy(value ctx_in)
{
     SHA1_CTX *ctx = (SHA1_CTX *)ctx_in;
     SHA1_CTX *new_ctx;

     new_ctx = (SHA1_CTX *)alloc(sizeof(SHA1_CTX) / sizeof(value), Abstract_tag);
     *new_ctx = *ctx;
     return (value) new_ctx;
}

value sha1init()
{
     SHA1_CTX *ctx;

     ctx = (SHA1_CTX *)alloc(sizeof(SHA1_CTX) / sizeof(value), Abstract_tag);
     SHA1Init(ctx);
     return (value) ctx;
}

value sha1update(value ctx_in, value str)
{
     SHA1_CTX *ctx = (SHA1_CTX *)ctx_in;
     char *cp;

     cp = String_val(str);
     SHA1Update(ctx, cp, string_length(str));

     return Val_unit;
}

value sha1final(value ctx_in)
{
     SHA1_CTX *ctx = (SHA1_CTX *)ctx_in;
     value str;
     char *cp;

     str = alloc_string(20);
     cp = String_val(str);
     SHA1Final(cp, ctx);
     return str;
}
